/************************************
  HAZE Trial Keygen
  Keygen by jB

  Date: 08/02/2004
  Protection: Matrix 6x6


  Initialisation de la matrice: 

      [-.2, -.4,  .6,  .4,  .2, -.4]
      [-.4,  .2,  .2,  .8, -.6,  .2]
	  [ .8,  .6, -.4, -.6,  .2, -.4]
  M = [-.2, -.4,  .6,  .4, -.8,  .6]
	  [-.4,  .2,  .2, -.2,  .4,  .2]
	  [ .6,  .2, -.8, -.2,  .4,  .2]

  A partir du nom on gnre un tableau arV de 6 int.

  Le serial, compos de 6 nombres en base 36, est converti en tableau arSerial d'int (en fait un vecteur colonne).
  On doit avoir: M * arSerial = arV

  On calcule donc M^(-1) = 
	[1, 0, 1, 1, 0, 1]
	[0, 1, 1, 0, 1, 0]
	[1, 0, 1, 1, 1, 0]
	[1, 1, 0, 0, 0, 1]
	[1, 0, 0, 0, 1, 1]
	[0, 0, 0, 1, 1, 1]

  On a: arSerial = M^(-1) * arV.
  On convertit les lments de arSerial en base 36 et on affiche le rsultat.

************************************/

#include "stdafx.h"
#include <string.h>
#include <stdlib.h>
#include <stdio.h>

int main(int argc, char* argv[])
{
	char szName[50];
	int arV[6];
	int arM[36]={1,0,1,1,0,1,0,1,1,0,1,0,1,0,1,1,1,0,1,1,0,0,0,1,1,0,0,0,1,1,0,0,0,1,1,1};
	int arSerial[6];
	int len,i,j;
	char temp[10];
	char serial[50]="";

	printf("HAZE Trial KeygenMe\nKeygen by jB\n\nName:\t");
	gets(szName);
	len=strlen(szName);
	if(!len)
		printf("Please enter a name\n");
	else {		
		for(i=0,arV[0]=0;i<len;i++)
			arV[0]=arV[0]+szName[i]*0x17544+0x649d9;

		__asm{
		mov edx, dword ptr [arV]
		lea	eax, [edx+edx*2]
		shl	eax, 6
		mov	[arV+4], eax
		lea	eax, [edx-4]
		lea	ecx, ds:0[eax*8]
		sub	ecx, eax
		shl	ecx, 5
		sub	ecx, eax
		lea	eax, [edx+edx*2]
		mov	[arV+8], ecx
		lea	eax, [eax+eax*4]
		xor	eax, 11D1h
		mov	[arV+12], eax
		mov	eax, 3EE9F3h
		sub	eax, edx
		sar	eax, 2
		lea	ecx, [eax+eax*4]
		shl	ecx, 6
		add	ecx, eax
		shl	ecx, 4
		add	ecx, eax
		lea	eax, [edx+edx*4]
		lea	ecx, [ecx+ecx*2]
		lea	eax, [edx+eax*4]
		shl	ecx, 2
		mov	[arV+16], ecx
		lea	ecx, [eax+eax*4]
		mov	eax, 4EC4EC4Fh
		lea	ecx, [edx+ecx*2]
		add	ecx, ecx
		imul	ecx
		sar	edx, 2
		mov	eax, edx
		shr	eax, 1Fh
		add	edx, eax
		xor	eax, eax
		mov	[arV+20], edx
		}

		for(i=0;i<6;i++)
			arV[i]&=0xFFFFF;
		for(i=0;i<6;i++) {
			arSerial[i]=0;
			for(j=0;j<6;j++)
				arSerial[i]+=arM[i*6+j]*arV[j];
		}
		for(i=0;i<6;i++) {
			_ultoa(arSerial[i],temp,36);
			strcat(serial,temp);
			strcat(serial,"-");
		}
		serial[strlen(serial)-1]=0;
		_strupr(serial);
		printf("Serial:\t %s\n",serial);
		getchar();
	}
	return 0;
}

